pcl::registration::ELCH< PointT > Class Template Reference
Module registration

ELCH (Explicit Loop Closing Heuristic) class More...

`#include <pcl/registration/elch.h>`

Inheritance diagram for pcl::registration::ELCH< PointT >:

## Classes

struct | Vertex

## Public Types

using | Ptr = shared_ptr< ELCH< PointT > >
using | ConstPtr = shared_ptr< const ELCH< PointT > >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | LoopGraph = boost::adjacency_list< boost::listS, boost::eigen_vecS, boost::undirectedS, Vertex, boost::no_property >
| graph structure to hold the SLAM graph More...
using | LoopGraphPtr = shared_ptr< LoopGraph >
using | Registration = pcl::Registration< PointT, PointT >
using | RegistrationPtr = typename Registration::Ptr
using | RegistrationConstPtr = typename Registration::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| ELCH ()
| Empty constructor. More...
| ~ELCH ()
| Empty destructor. More...
void | addPointCloud (PointCloudPtr cloud)
| Add a new point cloud to the internal graph. More...
LoopGraphPtr | getLoopGraph ()
| Getter for the internal graph. More...
void | setLoopGraph (LoopGraphPtr loop_graph)
| Setter for a new internal graph. More...
boost::graph_traits< LoopGraph >::vertex_descriptor | getLoopStart ()
| Getter for the first scan of a loop. More...
void | setLoopStart (const typename boost::graph_traits< LoopGraph >::vertex_descriptor &loop_start)
| Setter for the first scan of a loop. More...
boost::graph_traits< LoopGraph >::vertex_descriptor | getLoopEnd ()
| Getter for the last scan of a loop. More...
void | setLoopEnd (const typename boost::graph_traits< LoopGraph >::vertex_descriptor &loop_end)
| Setter for the last scan of a loop. More...
RegistrationPtr | getReg ()
| Getter for the registration algorithm. More...
void | setReg (RegistrationPtr reg)
| Setter for the registration algorithm. More...
Eigen::Matrix4f | getLoopTransform ()
| Getter for the transformation between the first and the last scan. More...
void | setLoopTransform (const Eigen::Matrix4f &loop_transform)
| Setter for the transformation between the first and the last scan. More...
void | compute ()
| Computes new poses for all point clouds by closing the loop between start and end point cloud. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT>
class pcl::registration::ELCH< PointT >

ELCH (Explicit Loop Closing Heuristic) class

Author
  Jochen Sprickerhof

Definition at line 59 of file elch.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT >

using pcl::registration::ELCH< PointT >::ConstPtr = shared_ptr<const ELCH<PointT> >

Definition at line 62 of file elch.h.

## LoopGraph

template<typename PointT >

using pcl::registration::ELCH< PointT >::LoopGraph = boost::adjacency_list<boost::listS, boost::eigen_vecS, boost::undirectedS, Vertex, boost::no_property>

graph structure to hold the SLAM graph

Definition at line 75 of file elch.h.

## LoopGraphPtr

template<typename PointT >

using pcl::registration::ELCH< PointT >::LoopGraphPtr = shared_ptr<LoopGraph>

Definition at line 81 of file elch.h.

## PointCloud

template<typename PointT >

using pcl::registration::ELCH< PointT >::PointCloud = pcl::PointCloud<PointT>

Definition at line 64 of file elch.h.

## PointCloudConstPtr

template<typename PointT >

using pcl::registration::ELCH< PointT >::PointCloudConstPtr = typename PointCloud::ConstPtr

Definition at line 66 of file elch.h.

## PointCloudPtr

template<typename PointT >

using pcl::registration::ELCH< PointT >::PointCloudPtr = typename PointCloud::Ptr

Definition at line 65 of file elch.h.

## Ptr

template<typename PointT >

using pcl::registration::ELCH< PointT >::Ptr = shared_ptr<ELCH<PointT> >

Definition at line 61 of file elch.h.

## Registration

template<typename PointT >

using pcl::registration::ELCH< PointT >::Registration = pcl::Registration<PointT, PointT>

Definition at line 83 of file elch.h.

## RegistrationConstPtr

template<typename PointT >

using pcl::registration::ELCH< PointT >::RegistrationConstPtr = typename Registration::ConstPtr

Definition at line 85 of file elch.h.

## RegistrationPtr

template<typename PointT >

using pcl::registration::ELCH< PointT >::RegistrationPtr = typename Registration::Ptr

Definition at line 84 of file elch.h.

## Constructor & Destructor Documentation

## ELCH()

template<typename PointT >

pcl::registration::ELCH< PointT >::ELCH | ( |  | ) |

inline

Empty constructor.

Definition at line 88 of file elch.h.

## ~ELCH()

template<typename PointT >

pcl::registration::ELCH< PointT >::~ELCH | ( |  | ) |

inline

Empty destructor.

Definition at line 97 of file elch.h.

## Member Function Documentation

## addPointCloud()

template<typename PointT >

void pcl::registration::ELCH< PointT >::addPointCloud | ( | PointCloudPtr | cloud | ) |

inline

Add a new point cloud to the internal graph.

Parameters

  [in] | cloud | the new point cloud

Definition at line 103 of file elch.h.

## compute()

template<typename PointT >

void pcl::registration::ELCH< PointT >::compute

Computes new poses for all point clouds by closing the loop between start and end point cloud.

This will transform all given point clouds for now!

Definition at line 216 of file elch.hpp.

References pcl::transformPointCloud().

## getLoopEnd()

template<typename PointT >

boost::graph_traits<LoopGraph>::vertex_descriptor pcl::registration::ELCH< PointT >::getLoopEnd | ( |  | ) |

inline

Getter for the last scan of a loop.

Definition at line 148 of file elch.h.

## getLoopGraph()

template<typename PointT >

LoopGraphPtr pcl::registration::ELCH< PointT >::getLoopGraph | ( |  | ) |

inline

Getter for the internal graph.

Definition at line 115 of file elch.h.

## getLoopStart()

template<typename PointT >

boost::graph_traits<LoopGraph>::vertex_descriptor pcl::registration::ELCH< PointT >::getLoopStart | ( |  | ) |

inline

Getter for the first scan of a loop.

Definition at line 131 of file elch.h.

## getLoopTransform()

template<typename PointT >

Eigen::Matrix4f pcl::registration::ELCH< PointT >::getLoopTransform | ( |  | ) |

inline

Getter for the transformation between the first and the last scan.

Definition at line 181 of file elch.h.

## getReg()

template<typename PointT >

RegistrationPtr pcl::registration::ELCH< PointT >::getReg | ( |  | ) |

inline

Getter for the registration algorithm.

Definition at line 164 of file elch.h.

## initCompute()

template<typename PointT >

bool pcl::registration::ELCH< PointT >::initCompute

protected virtual

This method should get called before starting the actual computation.

Definition at line 154 of file elch.hpp.

## setLoopEnd()

template<typename PointT >

void pcl::registration::ELCH< PointT >::setLoopEnd | ( | const typename boost::graph_traits< LoopGraph >::vertex_descriptor & | loop_end | ) |

inline

Setter for the last scan of a loop.

Parameters

  [in] | loop_end | the scan that ends the loop

Definition at line 157 of file elch.h.

## setLoopGraph()

template<typename PointT >

void pcl::registration::ELCH< PointT >::setLoopGraph | ( | LoopGraphPtr | loop_graph | ) |

inline

Setter for a new internal graph.

Parameters

  [in] | loop_graph | the new graph

Definition at line 124 of file elch.h.

## setLoopStart()

template<typename PointT >

void pcl::registration::ELCH< PointT >::setLoopStart | ( | const typename boost::graph_traits< LoopGraph >::vertex_descriptor & | loop_start | ) |

inline

Setter for the first scan of a loop.

Parameters

  [in] | loop_start | the scan that starts the loop

Definition at line 140 of file elch.h.

## setLoopTransform()

template<typename PointT >

void pcl::registration::ELCH< PointT >::setLoopTransform | ( | const Eigen::Matrix4f & | loop_transform | ) |

inline

Setter for the transformation between the first and the last scan.

Parameters

  [in] | loop_transform | the transformation between the first and the last scan

Definition at line 190 of file elch.h.

## setReg()

template<typename PointT >

void pcl::registration::ELCH< PointT >::setReg | ( | RegistrationPtr | reg | ) |

inline

Setter for the registration algorithm.

Parameters

  [in] | reg | the registration algorithm used to compute the transformation between the start and the end of the loop

Definition at line 174 of file elch.h.

The documentation for this class was generated from the following files:

- pcl/registration/elch.h
- pcl/registration/impl/elch.hpp